Index: cpukit/include/rtems/rtl/rtl-obj.h
===================================================================
--- cpukit/include/rtems/rtl/rtl-obj.h	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/include/rtems/rtl/rtl-obj.h	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -208,5 +208,5 @@
   void*               const_base;   /**< The base address of the const section
                                      *   in memory. */
-  size_t              const_size;    /**< The size of the const section. */
+  size_t              const_size;   /**< The size of the const section. */
   void*               eh_base;      /**< The base address of the eh section in
                                      *   memory. */
@@ -228,8 +228,12 @@
   void*               trampoline;   /**< Trampoline memory. Used for fixups or
                                      *   veneers */
-  size_t              tramp_size;   /**< Size of the tramopline memory. */
+  size_t              tramp_size;   /**< Size of a tramopline slot. */
+  size_t              tramps_size;  /**< Size of the trampoline memory. */
   void*               tramp_brk;    /**< Trampoline memory allocator. MD
                                      *   relocators can take memory from the
                                      *   break upto the size. */
+  size_t              tramp_relocs; /**< Number of slots reserved for
+                                     *   relocs. The remainder are for
+                                     *   unresolved symbols. */
   struct link_map*    linkmap;      /**< For GDB. */
   void*               loader;       /**< The file details specific to a
@@ -371,9 +375,33 @@
  * @retval bool Returns @true if the space is available.
  */
-static inline bool rtems_rtl_obj_has_ramp_space (const rtems_rtl_obj* obj,
-                                                 const size_t         size)
+static inline bool rtems_rtl_obj_has_tramp_space (const rtems_rtl_obj* obj,
+                                                  const size_t         size)
 {
   return (obj->trampoline != NULL &&
-          ((obj->tramp_brk - obj->trampoline) + size) <= obj->tramp_size);
+          ((obj->tramp_brk - obj->trampoline) + size) <= obj->tramps_size);
+}
+
+/**
+ * Trampoline slots.
+ *
+ * @param obj The object file's descriptor.
+ * @retval size_t The number of trampoline slots.
+ */
+static inline size_t rtems_rtl_obj_trampoline_slots (const rtems_rtl_obj* obj)
+{
+  return obj->trampoline == NULL || obj->tramp_size == 0 ?
+    0 : obj->tramps_size / obj->tramp_size;
+}
+
+/**
+ * Number of trampolines.
+ *
+ * @param obj The object file's descriptor.
+ * @retval size_t The number of trampolines.
+ */
+static inline size_t rtems_rtl_obj_trampolines (const rtems_rtl_obj* obj)
+{
+  return obj->trampoline == NULL || obj->tramp_size == 0 ?
+    0 : (obj->tramp_brk - obj->trampoline) / obj->tramp_size;
 }
 
Index: cpukit/include/rtems/rtl/rtl-unresolved.h
===================================================================
--- cpukit/include/rtems/rtl/rtl-unresolved.h	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/include/rtems/rtl/rtl-unresolved.h	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -1,4 +1,4 @@
 /*
- *  COPYRIGHT (c) 2012, 2018 Chris Johns <chrisj@rtems.org>
+ *  COPYRIGHT (c) 2012, 2019 Chris Johns <chrisj@rtems.org>
  *
  *  The license and distribution terms for this file may be
@@ -74,5 +74,6 @@
   rtems_rtl_unresolved_empty = 0,  /**< The records is empty. Must always be 0 */
   rtems_rtl_unresolved_symbol = 1, /**< The record is a symbol. */
-  rtems_rtl_unresolved_reloc = 2   /**< The record is a relocation record. */
+  rtems_rtl_unresolved_reloc = 2,  /**< The record is a relocation record. */
+  rtems_rtl_trampoline_reloc = 3   /**< The record is a trampoline relocation record. */
 } rtems_rtl_unresolved_rtype;
 
@@ -102,5 +103,5 @@
 /**
  * Unresolved externals symbols require the relocation records to be held
- * and references.
+ * and referenced.
  */
 typedef struct rtems_rtl_unresolv_reloc
@@ -114,4 +115,16 @@
 
 /**
+ * Trampolines require the relocation records to be held
+ */
+typedef struct rtems_rtl_tramp_reloc
+{
+  rtems_rtl_obj* obj;      /**< The relocation's object file. */
+  uint16_t       flags;    /**< Format specific flags. */
+  uint16_t       sect;     /**< The target section. */
+  rtems_rtl_word symvalue; /**< The symbol's value. */
+  rtems_rtl_word rel[3];   /**< Relocation record. */
+} rtems_rtl_tramp_reloc;
+
+/**
  * Unresolved externals records.
  */
@@ -122,5 +135,6 @@
   {
     rtems_rtl_unresolv_symbol name;   /**< The symbol, or */
-    rtems_rtl_unresolv_reloc  reloc;  /**< the relocation record. */
+    rtems_rtl_unresolv_reloc  reloc;  /**< The relocation record. */
+    rtems_rtl_tramp_reloc     tramp;  /**< The trampoline relocation record. */
   } rec;
 } rtems_rtl_unresolv_rec;
Index: cpukit/include/rtems/rtl/rtl.h
===================================================================
--- cpukit/include/rtems/rtl/rtl.h	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/include/rtems/rtl/rtl.h	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -73,5 +73,5 @@
  * The number of relocation record per block in the unresolved table.
  */
-#define RTEMS_RTL_UNRESOLVED_BLOCK_SIZE (64)
+#define RTEMS_RTL_UNRESOLVED_BLOCK_SIZE (256)
 
 /**
Index: cpukit/libdl/rtl-allocator.c
===================================================================
--- cpukit/libdl/rtl-allocator.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-allocator.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -148,5 +148,5 @@
 
   if (rtems_rtl_trace (RTEMS_RTL_TRACE_ALLOCATOR))
-    printf ("rtl: alloc: wr-enable: addr=%p\n", address);
+    printf ("rtl: alloc: wr-disable: addr=%p\n", address);
 
   if (rtl != NULL && address != NULL)
Index: cpukit/libdl/rtl-elf.c
===================================================================
--- cpukit/libdl/rtl-elf.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-elf.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -1,4 +1,4 @@
 /*
- *  COPYRIGHT (c) 2012-2018 Chris Johns <chrisj@rtems.org>
+ *  COPYRIGHT (c) 2012-2019 Chris Johns <chrisj@rtems.org>
  *
  *  The license and distribution terms for this file may be
@@ -32,9 +32,10 @@
 #include "rtl-error.h"
 #include <rtems/rtl/rtl-trace.h>
+#include "rtl-trampoline.h"
 #include "rtl-unwind.h"
 #include <rtems/rtl/rtl-unresolved.h>
 
 /**
- * The offsets in the unresolved array.
+ * The offsets in the reloc words.
  */
 #define REL_R_OFFSET (0)
@@ -167,64 +168,75 @@
 {
   rtems_rtl_elf_reloc_data* rd = (rtems_rtl_elf_reloc_data*) data;
-
-  /*
-   * The symbol has to have been resolved to parse the reloc record. Unresolved
-   * symbols are handled in the relocator but we need to count them here so a
-   * trampoline is accounted for. We have to assume the unresolved may be out of
-   * of range.
-   */
-  if (!resolved)
-  {
-    ++rd->unresolved;
+  rtems_rtl_word            rel_words[3];
+  rtems_rtl_elf_rel_status  rs;
+
+  /*
+   * Check the reloc record to see if a trampoline is needed.
+   */
+  if (is_rela)
+  {
+    const Elf_Rela* rela = (const Elf_Rela*) relbuf;
+    if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+      printf ("rtl: rela tramp: sym: %c:%s(%d)=%08jx type:%d off:%08jx addend:%d\n",
+              ELF_ST_BIND (sym->st_info) == STB_GLOBAL ||
+              ELF_ST_BIND (sym->st_info) == STB_WEAK ? 'G' : 'L',
+              symname, (int) ELF_R_SYM (rela->r_info),
+              (uintmax_t) symvalue, (int) ELF_R_TYPE (rela->r_info),
+              (uintmax_t) rela->r_offset, (int) rela->r_addend);
+    rs = rtems_rtl_elf_relocate_rela_tramp (obj, rela, targetsect,
+                                            symname, sym->st_info, symvalue);
+    rel_words[REL_R_OFFSET] = rela->r_offset;
+    rel_words[REL_R_INFO] = rela->r_info;
+    rel_words[REL_R_ADDEND] = rela->r_addend;
   }
   else
   {
+    const Elf_Rel* rel = (const Elf_Rel*) relbuf;
+    if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+      printf ("rtl: rel tramp: sym: %c:%s(%d)=%08jx type:%d off:%08jx\n",
+              ELF_ST_BIND (sym->st_info) == STB_GLOBAL ||
+              ELF_ST_BIND (sym->st_info) == STB_WEAK ? 'G' : 'L',
+              symname, (int) ELF_R_SYM (rel->r_info),
+              (uintmax_t) symvalue, (int) ELF_R_TYPE (rel->r_info),
+              (uintmax_t) rel->r_offset);
+    rs = rtems_rtl_elf_relocate_rel_tramp (obj, rel, targetsect,
+                                           symname, sym->st_info, symvalue);
+    rel_words[REL_R_OFFSET] = rel->r_offset;
+    rel_words[REL_R_INFO] = rel->r_info;
+    rel_words[REL_R_ADDEND] = 0;
+  }
+
+  if (rs == rtems_rtl_elf_rel_failure)
+    return false;
+
+  if (rs == rtems_rtl_elf_rel_tramp_cache || rs == rtems_rtl_elf_rel_tramp_add)
+  {
+    uint32_t flags = (is_rela ? 1 : 0) | (resolved ? 0 : 1 << 1) | (sym->st_info << 8);
+    if (!rtems_rtl_trampoline_add (obj, flags,
+                                   targetsect->section, symvalue, rel_words))
+      return false;
+  }
+
+  /*
+   * Handle any dependencies if there is a valid symbol.
+   */
+  if (symname != NULL)
+  {
     /*
-     * Check the reloc record to see if a trampoline is needed.
+     * Find the symbol's object file. It cannot be NULL so ignore that result
+     * if returned, it means something is corrupted. We are in an iterator.
      */
-    if (is_rela)
-    {
-      const Elf_Rela* rela = (const Elf_Rela*) relbuf;
-      if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-        printf ("rtl: rela tramp: sym:%s(%d)=%08jx type:%d off:%08jx addend:%d\n",
-                symname, (int) ELF_R_SYM (rela->r_info),
-                (uintmax_t) symvalue, (int) ELF_R_TYPE (rela->r_info),
-                (uintmax_t) rela->r_offset, (int) rela->r_addend);
-      if (!rtems_rtl_elf_relocate_rela_tramp (obj, rela, targetsect,
-                                              symname, sym->st_info, symvalue))
-        return false;
-    }
-    else
-    {
-      const Elf_Rel* rel = (const Elf_Rel*) relbuf;
-      if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-        printf ("rtl: rel tramp: sym:%s(%d)=%08jx type:%d off:%08jx\n",
-                symname, (int) ELF_R_SYM (rel->r_info),
-                (uintmax_t) symvalue, (int) ELF_R_TYPE (rel->r_info),
-                (uintmax_t) rel->r_offset);
-      if (!rtems_rtl_elf_relocate_rel_tramp (obj, rel, targetsect,
-                                             symname, sym->st_info, symvalue))
-        return false;
-    }
-
-    if (symname != NULL)
+    rtems_rtl_obj*  sobj = rtems_rtl_find_obj_with_symbol (symbol);
+    if (sobj != NULL)
     {
       /*
-       * Find the symbol's object file. It cannot be NULL so ignore that result
-       * if returned, it means something is corrupted. We are in an iterator.
+       * A dependency is not the base kernel image or itself. Tag the object as
+       * having been visited so we count it only once.
        */
-      rtems_rtl_obj*  sobj = rtems_rtl_find_obj_with_symbol (symbol);
-      if (sobj != NULL)
-      {
-        /*
-         * A dependency is not the base kernel image or itself. Tag the object as
-         * having been visited so we count it only once.
-         */
-        if (sobj != rtems_rtl_baseimage () && obj != sobj &&
-            (sobj->flags & RTEMS_RTL_OBJ_RELOC_TAG) == 0)
-        {
-          sobj->flags |= RTEMS_RTL_OBJ_RELOC_TAG;
-          ++rd->dependents;
-        }
+      if (sobj != rtems_rtl_baseimage () && obj != sobj &&
+          (sobj->flags & RTEMS_RTL_OBJ_RELOC_TAG) == 0)
+      {
+        sobj->flags |= RTEMS_RTL_OBJ_RELOC_TAG;
+        ++rd->dependents;
       }
     }
@@ -279,5 +291,6 @@
   else
   {
-    rtems_rtl_obj* sobj;
+    rtems_rtl_obj*           sobj;
+    rtems_rtl_elf_rel_status rs;
 
     if (is_rela)
@@ -288,6 +301,7 @@
                 (uintmax_t) symvalue, (int) ELF_R_TYPE (rela->r_info),
                 (uintmax_t) rela->r_offset, (int) rela->r_addend);
-      if (!rtems_rtl_elf_relocate_rela (obj, rela, targetsect,
-                                        symname, sym->st_info, symvalue))
+      rs = rtems_rtl_elf_relocate_rela (obj, rela, targetsect,
+                                        symname, sym->st_info, symvalue);
+      if (rs != rtems_rtl_elf_rel_no_error)
         return false;
     }
@@ -299,6 +313,7 @@
                 (uintmax_t) symvalue, (int) ELF_R_TYPE (rel->r_info),
                 (uintmax_t) rel->r_offset);
-      if (!rtems_rtl_elf_relocate_rel (obj, rel, targetsect,
-                                       symname, sym->st_info, symvalue))
+      rs = rtems_rtl_elf_relocate_rel (obj, rel, targetsect,
+                                       symname, sym->st_info, symvalue);
+      if (rs != rtems_rtl_elf_rel_no_error)
         return false;
     }
@@ -420,5 +435,8 @@
      * Only need the name of the symbol if global or a common symbol.
      */
-    if (ELF_ST_TYPE (sym.st_info) == STT_NOTYPE ||
+    if (ELF_ST_TYPE (sym.st_info) == STT_OBJECT ||
+        ELF_ST_TYPE (sym.st_info) == STT_COMMON ||
+        ELF_ST_TYPE (sym.st_info) == STT_FUNC ||
+        ELF_ST_TYPE (sym.st_info) == STT_NOTYPE ||
         ELF_ST_TYPE (sym.st_info) == STT_TLS ||
         sym.st_shndx == SHN_COMMON)
@@ -492,8 +510,9 @@
                                    rtems_rtl_obj_sym*        sym)
 {
-  rtems_rtl_obj_sect* sect;
-  bool                is_rela;
-  Elf_Word            symvalue;
-  rtems_rtl_obj*      sobj;
+  rtems_rtl_obj_sect*      sect;
+  bool                     is_rela;
+  Elf_Word                 symvalue;
+  rtems_rtl_obj*           sobj;
+  rtems_rtl_elf_rel_status rs;
 
   is_rela = reloc->flags & 1;
@@ -517,6 +536,7 @@
                   (int) ELF_R_SYM (rela.r_info), (int) ELF_R_TYPE (rela.r_info),
                   (uintmax_t) rela.r_offset, (int) rela.r_addend);
-    if (!rtems_rtl_elf_relocate_rela (reloc->obj, &rela, sect,
-                                      sym->name, sym->data, symvalue))
+    rs = rtems_rtl_elf_relocate_rela (reloc->obj, &rela, sect,
+                                      sym->name, sym->data, symvalue);
+    if (rs != rtems_rtl_elf_rel_no_error)
       return false;
   }
@@ -530,6 +550,7 @@
               (int) ELF_R_SYM (rel.r_info), (int) ELF_R_TYPE (rel.r_info),
               (uintmax_t) rel.r_offset);
-    if (!rtems_rtl_elf_relocate_rel (reloc->obj, &rel, sect,
-                                     sym->name, sym->data, symvalue))
+    rs = rtems_rtl_elf_relocate_rel (reloc->obj, &rel, sect,
+                                     sym->name, sym->data, symvalue);
+    if (rs != rtems_rtl_elf_rel_no_error)
       return false;
   }
@@ -622,7 +643,105 @@
 }
 
+/**
+ * Struct to handle trampoline reloc recs in the unresolved table.
+ */
+typedef struct rtems_rtl_tramp_data
+{
+  bool           failure;
+  rtems_rtl_obj* obj;
+  size_t         count;
+  size_t         total;
+} rtems_rtl_tramp_data;
+
+static bool
+rtems_rtl_elf_tramp_resolve_reloc (rtems_rtl_unresolv_rec* rec,
+                                   void*                   data)
+{
+  rtems_rtl_tramp_data* td = (rtems_rtl_tramp_data*) data;
+  if (rec->type == rtems_rtl_trampoline_reloc)
+  {
+    const rtems_rtl_tramp_reloc* tramp = &rec->rec.tramp;
+
+    ++td->total;
+
+    if (tramp->obj == td->obj)
+    {
+      const rtems_rtl_obj_sect* targetsect;
+      Elf_Byte                  st_info;
+      Elf_Word                  symvalue;
+      rtems_rtl_elf_rel_status  rs;
+      bool*                     failure = (bool*) data;
+      const bool                is_rela = (tramp->flags & 1) == 1;
+      const bool                unresolved = (tramp->flags & (1 << 1)) != 0;
+
+      ++td->count;
+
+      targetsect = rtems_rtl_obj_find_section_by_index (tramp->obj, tramp->sect);
+      st_info = tramp->flags >> 8;
+      symvalue = tramp->symvalue;
+
+      if (is_rela)
+      {
+        Elf_Rela rela = {
+          .r_offset = tramp->rel[REL_R_OFFSET],
+          .r_info   = tramp->rel[REL_R_INFO],
+          .r_addend = tramp->rel[REL_R_ADDEND]
+        };
+        if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+          printf ("rtl: rela tramp: check: %c(%d)=%08jx type:%d off:%08jx addend:%d\n",
+                  ELF_ST_BIND (st_info) == STB_GLOBAL ||
+                  ELF_ST_BIND (st_info) == STB_WEAK ? 'G' : 'L',
+                  (int) ELF_R_SYM (rela.r_info),
+                  (uintmax_t) symvalue, (int) ELF_R_TYPE (rela.r_info),
+                  (uintmax_t) rela.r_offset, (int) rela.r_addend);
+        rs = rtems_rtl_elf_relocate_rela_tramp (tramp->obj, &rela, targetsect,
+                                                NULL, st_info, symvalue);
+      }
+      else
+      {
+        Elf_Rel rel = {
+          .r_offset = tramp->rel[REL_R_OFFSET],
+          .r_info   = tramp->rel[REL_R_INFO],
+        };
+        if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+          printf ("rtl: rel tramp: check: %c(%d)=%08jx type:%d off:%08jx\n",
+                  ELF_ST_BIND (st_info) == STB_GLOBAL ||
+                  ELF_ST_BIND (st_info) == STB_WEAK ? 'G' : 'L',
+                  (int) ELF_R_SYM (rel.r_info),
+                  (uintmax_t) symvalue, (int) ELF_R_TYPE (rel.r_info),
+                  (uintmax_t) rel.r_offset);
+        rs = rtems_rtl_elf_relocate_rel_tramp (tramp->obj, &rel, targetsect,
+                                               NULL, st_info, symvalue);
+      }
+
+      if (unresolved || rs == rtems_rtl_elf_rel_tramp_add)
+        tramp->obj->tramps_size += tramp->obj->tramp_size;
+      if (rs == rtems_rtl_elf_rel_failure)
+      {
+        *failure = true;
+        return true;
+      }
+    }
+  }
+
+  return false;
+}
+
 static bool
 rtems_rtl_elf_alloc_trampoline (rtems_rtl_obj* obj, size_t unresolved)
 {
+  rtems_rtl_tramp_data td =  { 0 };
+  td.obj = obj;
+  /*
+   * See which relocs are out of range and need a trampoline.
+   */
+  rtems_rtl_unresolved_iterate (rtems_rtl_elf_tramp_resolve_reloc, &td);
+  if (td.failure)
+    return false;
+  rtems_rtl_trampoline_remove (obj);
+  obj->tramp_relocs = obj->tramp_size == 0 ? 0 : obj->tramps_size / obj->tramp_size;
+  if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+    printf ("rtl: tramp:elf: tramps: %zu count:%zu total:%zu\n",
+            obj->tramp_relocs, td.count, td.total);
   /*
    * Add on enough space to handle the unresolved externals that need to be
@@ -630,6 +749,9 @@
    * trampolines.
    */
-  obj->tramp_size +=
-    rtems_rtl_elf_relocate_tramp_max_size () * unresolved;
+  obj->tramps_size += obj->tramp_size * unresolved;
+  if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+    printf ("rtl: tramp:elf: slots: %zu (%zu)\n",
+            obj->tramp_size == 0 ? 0 : obj->tramps_size / obj->tramp_size,
+            obj->tramps_size);
   return rtems_rtl_obj_alloc_trampoline (obj);
 }
@@ -654,8 +776,8 @@
 
 static bool
-rtems_rtl_elf_symbols (rtems_rtl_obj*      obj,
-                       int                 fd,
-                       rtems_rtl_obj_sect* sect,
-                       void*               data)
+rtems_rtl_elf_symbols_load (rtems_rtl_obj*      obj,
+                            int                 fd,
+                            rtems_rtl_obj_sect* sect,
+                            void*               data)
 {
   rtems_rtl_obj_cache* symbols;
@@ -721,17 +843,18 @@
      */
     if (rtems_rtl_trace (RTEMS_RTL_TRACE_SYMBOL))
-      printf ("rtl: sym:elf:%-2d name:%-2d:%-20s bind:%-2d " \
-              "type:%-2d sect:%d size:%d\n",
+      printf ("rtl: sym:elf:%-4d name:%-4d: %-20s: bind:%-2d " \
+              "type:%-2d sect:%-5d size:%-5d value:%d\n",
               sym, (int) symbol.st_name, name,
               (int) ELF_ST_BIND (symbol.st_info),
               (int) ELF_ST_TYPE (symbol.st_info),
               symbol.st_shndx,
-              (int) symbol.st_size);
-
-            /*
-         * If a duplicate forget it.
-         */
-        if (rtems_rtl_symbol_global_find (name))
-          continue;
+              (int) symbol.st_size,
+              (int) symbol.st_value);
+
+    /*
+     * If a duplicate forget it.
+     */
+    if (rtems_rtl_symbol_global_find (name))
+      continue;
 
     if ((symbol.st_shndx != 0) &&
@@ -776,5 +899,5 @@
           {
             if (rtems_rtl_trace (RTEMS_RTL_TRACE_SYMBOL))
-              printf ("rtl: sym:elf:%-2d name:%-2d:%-20s: global\n",
+              printf ("rtl: sym:elf:%-4d name:%-4d: %-20s: global\n",
                       sym, (int) symbol.st_name, name);
             ++globals;
@@ -785,5 +908,5 @@
         {
           if (rtems_rtl_trace (RTEMS_RTL_TRACE_SYMBOL))
-            printf ("rtl: sym:elf:%-2d name:%-2d:%-20s: local\n",
+            printf ("rtl: sym:elf:%-4d name:%-4d: %-20s: local\n",
                     sym, (int) symbol.st_name, name);
           ++locals;
@@ -850,5 +973,5 @@
                                          &symbol, sizeof (symbol)))
     {
-      if (locals)
+      if (obj->local_syms)
       {
         rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_SYMBOL, obj->local_table);
@@ -857,5 +980,5 @@
         obj->local_syms = 0;
       }
-      if (globals)
+      if (obj->global_syms)
       {
         rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_SYMBOL, obj->global_table);
@@ -876,76 +999,111 @@
           (ELF_ST_BIND (symbol.st_info) == STB_LOCAL)))
     {
+      rtems_rtl_obj_sym* osym;
+      char*              string;
+      Elf_Word           value;
+      const char*        name;
+
+      off = obj->ooffset + strtab->offset + symbol.st_name;
+      len = RTEMS_RTL_ELF_STRING_MAX;
+
+      if (!rtems_rtl_obj_cache_read (strings, fd, off, (void**) &name, &len))
+        return false;
+
+      /*
+       * If a duplicate forget it.
+       */
+      if (rtems_rtl_symbol_global_find (name))
+        continue;
+
+      if ((ELF_ST_BIND (symbol.st_info) == STB_GLOBAL) ||
+          (ELF_ST_BIND (symbol.st_info) == STB_WEAK))
+      {
+        osym = gsym;
+        string = gstring;
+        gstring += strlen (name) + 1;
+        ++gsym;
+      }
+      else
+      {
+        osym = lsym;
+        string = lstring;
+        lstring += strlen (name) + 1;
+        ++lsym;
+      }
+
+      /*
+       * Allocate any common symbols in the common section.
+       */
+      if (symbol.st_shndx == SHN_COMMON)
+      {
+        size_t value_off = rtems_rtl_obj_align (common_offset,
+                                                symbol.st_value);
+        common_offset = value_off + symbol.st_size;
+        value = value_off;
+      }
+      else
+      {
+        value = symbol.st_value;
+      }
+
+      rtems_chain_set_off_chain (&osym->node);
+      memcpy (string, name, strlen (name) + 1);
+      osym->name = string;
+      osym->value = (uint8_t*) value;
+      osym->data = symbol.st_shndx;
+
+      if (rtems_rtl_trace (RTEMS_RTL_TRACE_SYMBOL))
+        printf ("rtl: sym:add:%-4d name:%-4d: %-20s: bind:%-2d " \
+                "type:%-2d val:%-8p sect:%-3d size:%d\n",
+                sym, (int) symbol.st_name, osym->name,
+                (int) ELF_ST_BIND (symbol.st_info),
+                (int) ELF_ST_TYPE (symbol.st_info),
+                osym->value, symbol.st_shndx,
+                (int) symbol.st_size);
+    }
+  }
+
+  return true;
+}
+
+static bool
+rtems_rtl_elf_symbols_locate (rtems_rtl_obj*      obj,
+                              int                 fd,
+                              rtems_rtl_obj_sect* sect,
+                              void*               data)
+{
+  int sym;
+
+  for (sym = 0; sym < obj->local_syms; ++sym)
+  {
+      rtems_rtl_obj_sym*  osym = &obj->local_table[sym];
       rtems_rtl_obj_sect* symsect;
-      rtems_rtl_obj_sym*  osym;
-      char*               string;
-      Elf_Word            value;
-
-      symsect = rtems_rtl_obj_find_section_by_index (obj, symbol.st_shndx);
+      symsect = rtems_rtl_obj_find_section_by_index (obj, osym->data);
       if (symsect)
       {
-        const char* name;
-
-        off = obj->ooffset + strtab->offset + symbol.st_name;
-        len = RTEMS_RTL_ELF_STRING_MAX;
-
-        if (!rtems_rtl_obj_cache_read (strings, fd, off, (void**) &name, &len))
-          return false;
-
-        /*
-         * If a duplicate forget it.
-         */
-        if (rtems_rtl_symbol_global_find (name))
-          continue;
-
-        if ((ELF_ST_BIND (symbol.st_info) == STB_GLOBAL) ||
-            (ELF_ST_BIND (symbol.st_info) == STB_WEAK))
-        {
-          osym = gsym;
-          string = gstring;
-          gstring += strlen (name) + 1;
-          ++gsym;
-        }
-        else
-        {
-          osym = lsym;
-          string = lstring;
-          lstring += strlen (name) + 1;
-          ++lsym;
-        }
-
-        /*
-         * Allocate any common symbols in the common section.
-         */
-        if (symbol.st_shndx == SHN_COMMON)
-        {
-          size_t value_off = rtems_rtl_obj_align (common_offset,
-                                                  symbol.st_value);
-          common_offset = value_off + symbol.st_size;
-          value = value_off;
-        }
-        else
-        {
-          value = symbol.st_value;
-        }
-
-        rtems_chain_set_off_chain (&osym->node);
-        memcpy (string, name, strlen (name) + 1);
-        osym->name = string;
-        osym->value = value + (uint8_t*) symsect->base;
-        osym->data = symbol.st_info;
-
+        osym->value += (intptr_t) symsect->base;
         if (rtems_rtl_trace (RTEMS_RTL_TRACE_SYMBOL))
-          printf ("rtl: sym:add:%-2d name:%-2d:%-20s bind:%-2d " \
-                  "type:%-2d val:%8p sect:%d size:%d\n",
-                  sym, (int) symbol.st_name, osym->name,
-                  (int) ELF_ST_BIND (symbol.st_info),
-                  (int) ELF_ST_TYPE (symbol.st_info),
-                  osym->value, symbol.st_shndx,
-                  (int) symbol.st_size);
-      }
-    }
-  }
-
-  if (globals)
+          printf ("rtl: sym:locate:local :%-4d name: %-20s val:%-8p sect:%-3d (%s, %p)\n",
+                  sym, osym->name, osym->value, osym->data,
+                  symsect->name, symsect->base);
+      }
+  }
+
+  for (sym = 0; sym < obj->global_syms; ++sym)
+  {
+      rtems_rtl_obj_sym*  osym = &obj->global_table[sym];
+      rtems_rtl_obj_sect* symsect;
+      symsect = rtems_rtl_obj_find_section_by_index (obj, osym->data);
+      if (symsect)
+      {
+        osym->value += (intptr_t) symsect->base;
+        if (rtems_rtl_trace (RTEMS_RTL_TRACE_SYMBOL))
+          printf ("rtl: sym:locate:global:%-4d name: %-20s val:%-8p sect:%-3d (%s, %p)\n",
+                  sym, osym->name, osym->value, osym->data,
+                  symsect->name, symsect->base);
+      }
+  }
+
+  if (obj->global_size)
     rtems_rtl_symbol_obj_add (obj);
 
@@ -1436,4 +1594,9 @@
 
   /*
+   * Set the format's architecture's maximum tramp size.
+   */
+  obj->tramp_size = rtems_rtl_elf_relocate_tramp_max_size ();
+
+  /*
    * Parse the section information first so we have the memory map of the object
    * file and the memory allocated. Any further allocations we make to complete
@@ -1444,6 +1607,15 @@
 
   /*
-   * See if there are any common variables and if there are add a common
-   * section.
+   * Set the entry point if there is one.
+   */
+  obj->entry = (void*)(uintptr_t) ehdr.e_entry;
+
+  /*
+   * Load the symbol table.
+   *
+   * 1. See if there are any common variables and if there are add a
+   *    common section.
+   * 2. Add up the common.
+   * 3.
    */
   if (!rtems_rtl_obj_load_symbols (obj, fd, rtems_rtl_elf_common, &common))
@@ -1451,9 +1623,13 @@
   if (!rtems_rtl_elf_add_common (obj, common.size, common.alignment))
     return false;
-
-  /*
-   * Set the entry point if there is one.
-   */
-  obj->entry = (void*)(uintptr_t) ehdr.e_entry;
+  if (!rtems_rtl_obj_load_symbols (obj, fd, rtems_rtl_elf_symbols_load, &ehdr))
+    return false;
+
+  /*
+   * Parse the relocation records. It lets us know how many dependents
+   * and fixup trampolines there are.
+   */
+  if (!rtems_rtl_obj_relocate (obj, fd, rtems_rtl_elf_relocs_parser, &relocs))
+    return false;
 
   /*
@@ -1469,4 +1645,18 @@
     return false;
 
+  if (!rtems_rtl_obj_load_symbols (obj, fd, rtems_rtl_elf_symbols_locate, &ehdr))
+    return false;
+
+  if (!rtems_rtl_elf_dependents (obj, &relocs))
+    return false;
+
+  if (!rtems_rtl_elf_alloc_trampoline (obj, relocs.unresolved))
+    return false;
+
+  /*
+   * Unlock the allocator.
+   */
+  rtems_rtl_alloc_unlock ();
+
   /*
    * Load the sections and symbols and then relocation to the base address.
@@ -1476,24 +1666,6 @@
 
   /*
-   * Parse the relocation records. It lets us know how many dependents
-   * and fixup trampolines there are.
-   */
-  if (!rtems_rtl_obj_relocate (obj, fd, rtems_rtl_elf_relocs_parser, &relocs))
-    return false;
-
-  if (!rtems_rtl_elf_dependents (obj, &relocs))
-    return false;
-
-  if (!rtems_rtl_elf_alloc_trampoline (obj, relocs.unresolved))
-    return false;
-
-  /*
-   * Unlock the allocator.
-   */
-  rtems_rtl_alloc_unlock ();
-
-  if (!rtems_rtl_obj_load_symbols (obj, fd, rtems_rtl_elf_symbols, &ehdr))
-    return false;
-
+   * Fix up the relocations.
+   */
   if (!rtems_rtl_obj_relocate (obj, fd, rtems_rtl_elf_relocs_locator, &ehdr))
     return false;
